## firmware-microbit-micropython 1.0.1

=== Makefile ===
ECHO = @echo

HEX_SRC = build/bbc-microbit-classic-gcc-nosd/source/microbit-micropython.hex
HEX_FINAL = build/firmware.hex
MBIT_VER_FILE = inc/genhdr/microbitversion.h
VER_ADDR_FILE = build/veraddr.txt

all: $(HEX_FINAL)

# Anything that depends on FORCE will be considered out-of-date
FORCE:
.PHONY: FORCE

$(HEX_FINAL): yotta $(VER_ADDR_FILE)
	tools/adduicr.py $(HEX_SRC) $$(cat $(VER_ADDR_FILE)) -o $(HEX_FINAL)
	@size $(HEX_SRC:.hex=)

yotta: $(MBIT_VER_FILE)
	@yt build

$(MBIT_VER_FILE): FORCE
	python tools/makeversionhdr.py $(MBIT_VER_FILE)

$(VER_ADDR_FILE): yotta
	@echo -n "0x" > $(VER_ADDR_FILE)
	@objdump -x $(HEX_SRC:.hex=) | grep microbit_version_string | cut -f 1 -d' ' >> $(VER_ADDR_FILE)

deploy: $(HEX_FINAL)
	$(ECHO) "Deploying $<"
	@mount /dev/sdb
	@sleep 1s
	@cp $< /mnt/
	@sleep 1s
	@umount /mnt

serial:
	@picocom /dev/ttyACM0 -b 115200

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/BBCMicrobitMicropython.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/BBCMicrobitMicropython.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/BBCMicrobitMicropython"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/BBCMicrobitMicropython"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== mbed-classic/CMakeLists.txt ===
#
# mbed-2 yotta-compatible build system
#

# make sure necessary features are enabled:
project(mbed-classic)
enable_language(ASM)

# override compilation flags:
if(CMAKE_C_COMPILER_ID MATCHES GNU)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
endif()

# the mbed.a library is built from two sets of source files + include
# directories:
#
# MBED_COMMON_SOURCES: the source files that are the same for all targets,
# these are easily found by globbing:
#
file(GLOB MBED_COMMON_SOURCES "common/*.cpp" "common/*.c")
#
# (always include the hal header directory, too)
set(MBED_COMMON_INCLUDE_DIRS "hal")

# and MBED_TARGET_SOURCES: these depend on which target we are building for. To
# find these we need to walk the directories in targets/, and wherever we see a
# TARGET_<something> name, recurse only if <something> matches what we're
# currently building for
macro(mbed_find_target_dirs PARENT_DIRECTORY SOURCES_LIST INCLUDES_LIST)
    # append this directory to the search path:
    list(APPEND ${INCLUDES_LIST} "${PARENT_DIRECTORY}")
    # add all source files in this directory to the sources list:
    file(GLOB sources "${PARENT_DIRECTORY}/*.cpp" "${PARENT_DIRECTORY}/*.c" "${PARENT_DIRECTORY}/*.s" "${PARENT_DIRECTORY}/*.S" )
    list(APPEND ${SOURCES_LIST} ${sources})
    
    # get a list of all subdirectories that we want to recurse into:
    file(GLOB dir_children RELATIVE "${PARENT_DIRECTORY}" "${PARENT_DIRECTORY}/*")
    set(matching_subdirs "")
    foreach(child ${dir_children})
      if(IS_DIRECTORY "${PARENT_DIRECTORY}/${child}")
          # is this directory name a magic one?
          if("${child}" MATCHES "^TARGET_")
              # target-magic: recurse if the MBED_LEGACY_TARGET_DEFINITIONS **list**
              # contains a matching value:
              foreach(legacy_magic_def ${MBED_LEGACY_TARGET_DEFINITIONS})
                  # we could probably unroll the list into a single regex if
                  # this is a performance problem:
                  if("${child}" MATCHES "^TARGET_${legacy_magic_def}$")
                      list(APPEND matching_subdirs ${child})
                      break()
                  endif()
              endforeach()
          elseif("${child}" MATCHES "^TOOLCHAIN_")
              # toolchain-magic: (recurse if the MBED_LEGACY_TOOLCHAIN matches
              # this name)
              if("${child}" MATCHES "^TOOLCHAIN_${MBED_LEGACY_TOOLCHAIN}$")
                  list(APPEND matching_subdirs "${child}")
              endif()
          else()
              # not special: always recurse into this directory
              list(APPEND matching_subdirs "${child}")
          endif()
      endif()
    endforeach()
    #message("matching_subdirs: ${matching_subdirs}")

    # recurse:
    foreach(subdir ${matching_subdirs})
        mbed_find_target_dirs("${PARENT_DIRECTORY}/${subdir}" ${SOURCES_LIST} ${INCLUDES_LIST})
    endforeach()
endmacro()

set(MBED_TARGET_SOURCES "")
set(MBED_TARGET_INCLUDE_DIRS "")
mbed_find_target_dirs("${CMAKE_CURRENT_SOURCE_DIR}/targets" MBED_TARGET_SOURCES MBED_TARGET_INCLUDE_DIRS)
#message("found target sources: ${MBED_TARGET_SOURCES}")
#message("found target include dirs: ${MBED_TARGET_INCLUDE_DIRS}")

# unfortunately, for ARMCC, the startup code needs to be provided as an object
# on the command line (not as part of an archive). To do this we override the
# CMake add_executable command.
if(CMAKE_C_COMPILER_ID STREQUAL "ARMCC")
    set(MBED_TARGET_STARTUP_CODE_SOURCES "")
    foreach(src ${MBED_TARGET_SOURCES})
        if("${src}" MATCHES .*startup_.*\\.[sS])
            LIST(APPEND MBED_TARGET_STARTUP_CODE_SOURCES "${src}")
        endif()
    endforeach()
    add_library(mbed_classic_startupcod OBJECT ${MBED_TARGET_STARTUP_CODE_SOURCES})
    macro (add_executable _name)
        _add_executable(${ARGV} $<TARGET_OBJECTS:mbed_classic_startupcod>)
    endmacro()
endif()

# we have to append any target-specific include dirs to the global include dirs
# list, so that any indirect includes (e.g. via mbed.h) of files in those
# directories will work:
# (non-target-specific include dirs are listed in extraIncludes in module.json)
foreach(dir ${MBED_TARGET_INCLUDE_DIRS})
    set_property(GLOBAL APPEND PROPERTY YOTTA_GLOBAL_INCLUDE_DIRS ${dir})
endforeach()

# finally, we can construct a library using the determined set of include paths
# + source files. Note that the library name must match the name of the yotta
# module (defined in module.json) for this module to link properly with other
# yotta modules.
include_directories(${MBED_COMMON_INCLUDE_DIRS})
include_directories(${MBED_TARGET_INCLUDE_DIRS})
add_library(mbed-classic
    ${MBED_COMMON_SOURCES}
    ${MBED_TARGET_SOURCES}
)
if(CMAKE_COMPILER_IS_GNUCC)
    target_link_libraries(mbed-classic
        -lnosys
    )
endif()

=== microbit-dal/source/CMakeLists.txt ===
# This file is no longer auto-generated to make the repository builds with GCC
# and ARMCC no matter what.

cmake_minimum_required(VERSION 2.8.12)

enable_language(ASM)

set(YOTTA_AUTO_MICROBIT-DAL_CPP_FILES
    "core/MemberFunctionCallback.cpp"
    "core/MicroBitCompat.cpp"
    "core/MicroBitDevice.cpp"
    "core/MicroBitFiber.cpp"
    "core/MicroBitFont.cpp"
    "core/MicroBitHeapAllocator.cpp"
    "core/MicroBitListener.cpp"
    "core/MicroBitSystemTimer.cpp"
    "core/MicroBitUtil.cpp"

    "types/CoordinateSystem.cpp"
    "types/ManagedString.cpp"
    "types/MicroBitEvent.cpp"
    "types/MicroBitImage.cpp"
    "types/PacketBuffer.cpp"
    "types/RefCounted.cpp"

    "drivers/DynamicPwm.cpp"
    "drivers/MicroBitAccelerometer.cpp"
    "drivers/MicroBitButton.cpp"
    "drivers/MicroBitCompass.cpp"
    "drivers/MicroBitCompassCalibrator.cpp"
    "drivers/MicroBitDisplay.cpp"
    "drivers/MicroBitI2C.cpp"
    "drivers/MicroBitIO.cpp"
    "drivers/MicroBitLightSensor.cpp"
    "drivers/MicroBitMessageBus.cpp"
    "drivers/MicroBitMultiButton.cpp"
    "drivers/MicroBitPin.cpp"
    "drivers/MicroBitQuadratureDecoder.cpp"
    "drivers/MicroBitRadio.cpp"
    "drivers/MicroBitRadioDatagram.cpp"
    "drivers/MicroBitRadioEvent.cpp"
    "drivers/MicroBitSerial.cpp"
    "drivers/MicroBitStorage.cpp"
    "drivers/MicroBitThermometer.cpp"
    "drivers/TimedInterruptIn.cpp"
    "drivers/MicroBitFlash.cpp"
    "drivers/MicroBitFile.cpp"
    "drivers/MicroBitFileSystem.cpp"
    "drivers/FXOS8700.cpp"
    "drivers/MMA8653.cpp"
    "drivers/MAG3110.cpp"
    "drivers/LSM303Accelerometer.cpp"
    "drivers/LSM303Magnetometer.cpp"
    "drivers/MicroBitMemoryMap.cpp"

    "bluetooth/MicroBitAccelerometerService.cpp"
    "bluetooth/MicroBitBLEManager.cpp"
    "bluetooth/MicroBitButtonService.cpp"
    "bluetooth/MicroBitDFUService.cpp"
    "bluetooth/MicroBitEddystone.cpp"
    "bluetooth/MicroBitEventService.cpp"
    "bluetooth/MicroBitIOPinService.cpp"
    "bluetooth/MicroBitLEDService.cpp"
    "bluetooth/MicroBitMagnetometerService.cpp"
    "bluetooth/MicroBitTemperatureService.cpp"
    "bluetooth/MicroBitUARTService.cpp"
    "bluetooth/MicroBitPartialFlashingService.cpp"

)

execute_process(WORKING_DIRECTORY "../../yotta_modules/${PROJECT_NAME}" COMMAND "git" "log" "--pretty=format:%h" "-n" "1" OUTPUT_VARIABLE git_hash)
execute_process(WORKING_DIRECTORY "../../yotta_modules/${PROJECT_NAME}" COMMAND "git" "rev-parse" "--abbrev-ref" "HEAD" OUTPUT_VARIABLE git_branch OUTPUT_STRIP_TRAILING_WHITESPACE)

if ("${git_branch}" STREQUAL "master")
    set(MICROBIT_DAL_VERSION_STRING "${YOTTA_MICROBIT_DAL_VERSION_STRING}")
else()
    set(MICROBIT_DAL_VERSION_STRING "${YOTTA_MICROBIT_DAL_VERSION_STRING}-${git_branch}-g${git_hash}")
endif()

set(MICROBIT_DAL_VERSION_FLAGS "-DMICROBIT_DAL_VERSION=\\\"${MICROBIT_DAL_VERSION_STRING}\\\"")

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${MICROBIT_DAL_VERSION_FLAGS}")

if (YOTTA_CFG_MICROBIT_CONFIGFILE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${YOTTA_FORCE_INCLUDE_FLAG} \"${YOTTA_CFG_MICROBIT_CONFIGFILE}\"")
endif ()

if(CMAKE_COMPILER_IS_GNUCC)
  file(REMOVE "asm/CortexContextSwitch.s")
  configure_file("asm/CortexContextSwitch.s.gcc" "asm/CortexContextSwitch.s" COPYONLY)
else()
  file(REMOVE "asm/CortexContextSwitch.s")
  configure_file("asm/CortexContextSwitch.s.armcc" "asm/CortexContextSwitch.s" COPYONLY)
endif()

set(YOTTA_AUTO_MICROBIT-DAL_S_FILES
    "asm/CortexContextSwitch.s"
)

add_library(microbit-dal
    ${YOTTA_AUTO_MICROBIT-DAL_CPP_FILES}
    ${YOTTA_AUTO_MICROBIT-DAL_S_FILES}
)

yotta_postprocess_target(LIBRARY microbit-dal)

target_link_libraries(microbit-dal
    mbed-classic
    ble
    ble-nrf51822
)

if(CMAKE_COMPILER_IS_GNUCC)
    message("suppressing ALL warnings from mbed-classic, ble, ble-nrf51822 & nrf51-sdk")
    target_compile_options(mbed-classic PRIVATE "-w")
    target_compile_options(ble PRIVATE "-w")
    target_compile_options(ble-nrf51822 PRIVATE "-w")
    target_compile_options(nrf51-sdk PRIVATE "-w")
endif()

=== debian/changelog ===
firmware-microbit-micropython (1.0.1-4) unstable; urgency=medium

  * d/control:
    - Declare compliance with Debian Policy 4.6.2 (no changes)
  * d/copyright:
    - Bump years of Debian copyright
  * d/rules:
    - Build with -std=gnu++14 to fix FTBFS with new clang.
      Thanks to Adrian Bunk for the NMU (Closes: #1026600)
    - Refresh dh_auto_clean override
  * d/watch:
    - Switch to watching Github tags rather than releases

 -- Nick Morrott <nickm@debian.org>  Fri, 24 Feb 2023 03:25:18 +0000

firmware-microbit-micropython (1.0.1-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control:
    - Update Maintainer field with new Debian Python Team contact address.
    - Update Vcs-* fields with new Debian Python Team Salsa layout.

  [ Nick Morrott ]
  * d/control:
    - Update standards version to 4.6.0, no changes needed.
  * d/copyright:
    - Refresh years of Debian copyright
    - Use 4-digit years for Debian copyright ranges
  * d/s/lintian-overrides
    - Refresh overrides against current lintian
  * d/u/metadata:
    - Remove obsolete fields Contact, Name
  * d/watch:
    - Update pattern for GitHub archive URLs

 -- Nick Morrott <nickm@debian.org>  Tue, 15 Feb 2022 11:57:55 +0000

firmware-microbit-micropython (1.0.1-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.

  [ Nick Morrott ]
  * d/control:
    - Bump Standards-Version to 4.5.0
    - Bump debhelper-compat level to 13
    - Set Rules-Requires-Root to no
    - Update Uploaders to use my Debian email address
    - Mark binary package as Multi-Arch: foreign
    - Suggest www-browser for documentation binary package
  * d/copyright:
    - Retab to remove extraneous tab characters
    - Refresh years of Debian copyright
  * d/patches:
    - Refresh patches (fuzz)
    - Add patch use-python3-in-makefile (Closes: #959640)
    - Add patch 1.0.1-documentation-fixes
  * d/{README.source,gbp.conf}:
    - Configure MUT components

 -- Nick Morrott <nickm@debian.org>  Wed, 17 Jun 2020 23:58:21 +0100

firmware-microbit-micropython (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #908783)

 -- Nick Morrott <knowledgejunkie@gmail.com>  Sat, 19 Jan 2019 17:24:43 +0100

=== debian/control ===
Source: firmware-microbit-micropython
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Nick Morrott <nickm@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 gcc-arm-none-eabi,
 libnewlib-arm-none-eabi,
 libssl-dev,
 libstdc++-arm-none-eabi-newlib,
 ninja-build,
 python3-setuptools,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 srecord,
 yotta,
Standards-Version: 4.6.2
Homepage: https://github.com/bbcmicrobit/micropython
Vcs-Browser: https://salsa.debian.org/python-team/packages/firmware-microbit-micropython
Vcs-Git: https://salsa.debian.org/python-team/packages/firmware-microbit-micropython.git
Rules-Requires-Root: no

Package: firmware-microbit-micropython
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Suggests:
 firmware-microbit-micropython-doc,
 picocom | screen,
Enhances:
 mu-editor,
 python3-uflash,
Conflicts:
 firmware-microbit-micropython-dl,
Description: MicroPython runtime for the BBC micro:bit
 This package provides a binary firmware file for the  BBC micro:bit
 small board computer (SBC), containing the MicroPython runtime.
 .
 It is suggested that a dedicated flashing tool (e.g. uflash) is used to
 upload the firmware and Python scripts to the micro:bit device.
 .
 The uflash utility (package: python3-uflash) uses the MicroPython runtime
 provided in this package as the default firmware to flash to the micro:bit.
 .
 This package contains the MicroPython runtime for the BBC micro:bit

Package: firmware-microbit-micropython-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Suggests:
 www-browser,
Description: MicroPython runtime for the BBC micro:bit (documentation)
 This package provides a binary firmware file for the  BBC micro:bit
 small board computer (SBC), containing the MicroPython runtime.
 .
 It is suggested that a dedicated flashing tool (e.g. uflash) is used to
 upload the firmware and Python scripts to the micro:bit device.
 .
 The uflash utility (package: python3-uflash) uses the MicroPython runtime
 provided in this package as the default firmware to flash to the micro:bit.
 .
 This package contains documentation for MicroPython on the BBC micro:bit

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export LANG=C.UTF-8
export LC_ALL=C.UTF-8

export DEB_CXXFLAGS_MAINT_APPEND += -std=gnu++14

%:
	dh $@ --with sphinxdoc

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build
	rm -rf tools/__pycache__
	rm -f inc/genhdr/microbitversion.h

override_dh_auto_build:
	# rename directories created from components tarballs (we note that
	# the underscore is not valid in the "component name" section of the
	# original source tarball filename, so must handle it here)
	mv yotta-targets yotta_targets
	mv yotta-modules yotta_modules
	# build the firmware
	make all
	# revert directories created from components tarballs
	mv yotta_targets yotta-targets
	mv yotta_modules yotta-modules
	# build documentation and remove sources
	PYTHONPATH=. http_proxy='127.0.0.1:9' https_proxy='127.0.0.1:9' python3 -m sphinx -N -bhtml docs/ build/html
	# fix duplicated images created by sphinx-build
	rm -f build/html/_images/speech-pitch1.png
	ln -sr build/html/_images/speech-pitch.png build/html/_images/speech-pitch1.png
	rm -f build/html/_images/scroll-hello1.gif
	ln -sr build/html/_images/scroll-hello.gif build/html/_images/scroll-hello1.gif
	rm -f build/html/_images/speech1.png
	ln -sr build/html/_images/speech.png build/html/_images/speech1.png

override_dh_fixperms:
	dh_fixperms
	find debian/firmware-microbit-micropython/usr/share/doc/firmware-microbit-micropython/examples \
			-name "*.py" -exec chmod -x '{}' \;

# all tests are executed on an attached micro:bit, so disable them
override_dh_auto_test:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
    https://github.com/bbcmicrobit/micropython/tags \
    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
